<script lang="ts" setup>
  defineEmits<{
    (e: 'close'): void;
  }>();

  withDefaults(
    defineProps<{
      visible?: boolean;
    }>(),
    {
      visible: false,
    },
  );

  const { start, isAppointmentInitializing, isAppointmentRunning, isAppointmentEnded, isPreview } =
    useAppointment();
  const endPresentationController = useModal();
  const layer = ref<string>();
  const { setup } = useVideoCall();
  const { loadState, switchSlide, slidesCount, loadPresentation } = usePresentation();
  const starting = ref(false);

  const nuxtApp = useNuxtApp();

  const startPresentation = async () => {
    try {
      nuxtApp.$setLoading(true, { mainClass: 'bg-white/80' });
      starting.value = true;
      await start();
      await Promise.all([loadState(), loadPresentation()]);
      // go to the first page
      await switchSlide(slidesCount.value ? 1 : 0);
      await setup();
    } finally {
      nuxtApp.$setLoading(false);
      starting.value = false;
    }
  };

  const tools = computed(() => [
    {
      icon: 'i-sw-solid:list',
      title: 'listing.productListings.headline',
      desc: 'listing.productListings.sublime',
      action: () => {
        layer.value = 'product-listing-layer';
      },
    },
    {
      icon: 'i-sw-solid:bookmark',
      title: 'product.savedProducts.headline',
      desc: 'product.savedProducts.sublime',
      action: () => {
        layer.value = 'saved-products-layer';
      },
    },
  ]);

  const close = () => {
    layer.value = undefined;
  };
</script>

<template>
  <SwSidebar @close="$emit('close')">
    <template #header>
      <div class="flex w-full flex-col">
        <p class="text-xl font-bold">
          {{ $t('presentation.guideTool.headline') }}
        </p>

        <p class="text-darkgray-subdued text-xs font-medium">
          <slot name="meta-info">{{ $t('presentation.guideTool.sublime') }}</slot>
        </p>
      </div>
    </template>

    <template #body>
      <div class="flex flex-col space-y-8 bg-white p-6">
        <!-- Tool section -->
        <ul class="flex flex-col space-y-2">
          <h4 class="text-base/6 font-bold">{{ $t('presentation.guideTool.tools') }}</h4>
          <li v-for="tool of tools" :key="tool.title">
            <button
              class="flex w-full cursor-pointer items-center space-x-3 py-2 text-left"
              @click="tool.action"
            >
              <div class="border-border flex-none rounded-md border px-3 py-2 font-medium">
                <span :class="['my-1 text-base', tool.icon]" />
              </div>
              <div class="grow">
                <div class="flex flex-col">
                  <h5 class="text-sm font-semibold">
                    {{ $t(tool.title) }}
                  </h5>
                  <span class="text-information-subdued text-xs font-medium">
                    {{ $t(tool.desc) }}
                  </span>
                </div>
              </div>
              <span class="i-sw-solid:chevron-right-xs shrink-0" />
            </button>
          </li>
        </ul>

        <!-- Preview presentation section -->
        <template v-if="isPreview">
          <div class="border-(border b)" />
          <SwEmptyState
            :title="$t('presentation.guideTool.previewPresentation')"
            :sublime="$t('presentation.guideTool.previewPresentationDescription')"
          >
            <template #icon>
              <span class="i-sw-solid:dolly m-auto p-0" />
            </template>
          </SwEmptyState>
        </template>

        <!-- Start presentation section -->
        <template v-else-if="isAppointmentInitializing">
          <div class="border-(border b)" />
          <div class="flex flex-col items-stretch">
            <h3 class="text-base font-bold">
              {{ $t('presentation.guideTool.startPresentation') }}
            </h3>
            <span class="text-information-subdued pt-1 text-sm/6">{{
              $t('presentation.guideTool.startPresentationDescription')
            }}</span>
            <SwButton :loading="starting" class="mt-4" size="large" @click="startPresentation">{{
              $t('presentation.guideTool.startPresentation')
            }}</SwButton>
          </div>
        </template>
        <!-- Setting section -->
        <template v-else-if="isAppointmentRunning">
          <div>
            <h4 class="text-base/6 font-bold">{{ $t('presentation.guideTool.settings') }}</h4>
            <!-- <div class="flex items-center space-x-3 pt-4">
              <div class="flex-none">
                <SwToggle />
              </div>
              <div class="grow items-center">
                <div class="flex flex-col">
                  <h5 class="text-sm font-semibold">
                    {{ $t('presentation.guideTool.lockPresentation.headline') }}
                  </h5>
                  <span class="text-information-subdued pt-0.5 text-xs">{{
                    $t('presentation.guideTool.lockPresentation.sublime')
                  }}</span>
                </div>
              </div>
            </div> -->
            <div class="flex items-center space-x-3 pt-6">
              <BroadcastModeSetup />
            </div>
          </div>

          <div class="border-(border t)" />

          <div class="flex flex-col items-stretch">
            <h4 class="text-base/6 font-bold">
              {{ $t('presentation.guideTool.endPresentation') }}
            </h4>
            <p class="text-information-subdued pt-0.5 pt-1 text-xs">
              {{ $t('presentation.guideTool.endPresentationDescription') }}
            </p>
            <SwButton
              variant="danger"
              class="mt-4"
              size="large"
              @click="endPresentationController.open"
            >
              {{ $t('presentation.guideTool.endPresentation') }}
            </SwButton>
          </div>
        </template>

        <!-- Ended presentation section -->
        <template v-else-if="isAppointmentEnded">
          <div class="border-(border b)" />
          <SwEmptyState
            :title="$t('presentation.guideTool.presentationHasEnded')"
            :sublime="$t('presentation.guideTool.endPresentationDescription')"
          >
            <template #icon>
              <span class="i-sw-solid:dolly m-auto p-0" />
            </template>
          </SwEmptyState>
        </template>
      </div>
    </template>

    <template #footer>
      <SlideNotes />
    </template>
  </SwSidebar>

  <ProductListingLayer v-if="layer === 'product-listing-layer'" @close="close" />

  <SavedProductsLayer v-if="layer === 'saved-products-layer'" @close="close" />

  <EndPresentationModal
    v-if="endPresentationController.isOpen.value"
    :controller="endPresentationController"
  />
</template>
